import java.math.BigInteger;
import java.util.Random;

/**
 * Die Klasse IDEA.
 * 
 * @author (ca) 
 * @version (mai06)
 */
public class IDEA
{
    private Random random=new Random();
    private int[] keys=new int[52];
    private int[] deKeys=new int[52];
    private int[] daten, code, deCode;

    /**
     * Konstruktor fr Objekte der Klasse IDEA
     */
    public IDEA()
    {
        setzeKey(random.nextInt(65536),random.nextInt(65536),random.nextInt(65536),random.nextInt(65536),
            random.nextInt(65536),random.nextInt(65536),random.nextInt(65536),random.nextInt(65536));
        makeKeys();
        makeDeKeys();
        daten= new int[4];
        code= new int[4];
        deCode= new int[4];
       // System.out.println("genderte Zuweisung der Umkehrschlssel, \n das war's aber wohl auch nicht. ");
    }
    
    /**
     * setzt die Daten.
     */
    public void setzeDaten(int a, int b, int c, int d){
        daten[0]=a;daten[1]=b;daten[2]=c;daten[3]=d;
    }

    /**
     * setzt den Code.
     */
    public void setzeCode(int a, int b, int c, int d){
        code[0]=a;code[1]=b;code[2]=c;code[3]=d;
    }

    // Schlsselerzeugung:
    public void makeKeys(){
        // Ausgangskey muss gesetzt sein!
        int[] temp=new int[8];
        for (int gruppenIndex=0;gruppenIndex<6;gruppenIndex++) {
            for (int i=0;i<8;i++) temp[i]=keys[gruppenIndex*8+i];
            temp=rotiere25bit(temp);
            if (gruppenIndex<5) for (int i=0;i<8;i++) keys[(gruppenIndex+1)*8+i]=temp[i];
            else for (int i=0;i<4;i++) keys[(gruppenIndex+1)*8+i]=temp[i];
        }
    }
    
     public void setzeKey(int a, int b, int c, int d, int e, int f, int g, int h){
         keys[0]=a; keys[1]=b; keys[2]=c; keys[3]=d; keys[4]=e; keys[5]=f; keys[6]=g; keys[7]=h; }
    
    private int[] rotiere25bit(int[] key){ // 8 Gruppenschlssel
        // 25 bit: 1*16+9, also 1 Stellen weiter und dann noch 9 bit.
        int[] temp=new int[8];
        for (int i=0;i<8;i++) temp[i]=key[(i+1)%8]; // einen 16 bit - Block schieben
        for (int i=0;i<8;i++) temp[i]=temp[i]<<9; // 9 bit intern
        for (int i=0;i<8;i++) temp[i]+=temp[(i+1)%8]/65536; // berlufe rber
        for (int i=0;i<8;i++) temp[i]=temp[i]%65536; // berlufe lschen
        return temp;
    }
    
    // Verschlsselung
    public int[] verschluessele(){
        int[] temp=daten;
        for (int i=0;i<8;i++) temp=runde(temp, keys, i);
        return schlussRunde(temp, keys);
    }
    
    public int[] entschluessele(){
        int[] temp=code;
        for (int i=0;i<8;i++) temp=runde(temp, deKeys, i);
        return schlussRunde(temp, deKeys);
    }
    
    private int[] runde(int[] daten, int[] derKey, int rundenIndex){
        int temp1=produkt(daten[0], derKey[6*rundenIndex]);
        int temp2=summe(daten[1], derKey[6*rundenIndex+1]);
        int temp3=summe(daten[2], derKey[6*rundenIndex+2]);
        int temp4=produkt(daten[3], derKey[6*rundenIndex+3]);
        int temp5=xor(temp1, temp3);
        int temp6=xor(temp2, temp4);
        int temp7=produkt(derKey[6*rundenIndex+4], temp5);
        int temp8=summe(temp7, temp6);
        int temp10=produkt(temp8, derKey[6*rundenIndex+5]);
        int temp9=summe(temp7, temp10);
        int[] result= {xor(temp1,temp10), xor(temp3,temp10), xor(temp2,temp9), xor(temp9,temp4)};
        // System.out.println("Daten 0:"+result[0]+" 1:"+result[1]+" 2:"+result[2]+" 3:"+result[3]);
        // System.out.println("key 0:"+derKey[6*rundenIndex]+" 1:"+derKey[6*rundenIndex+1]+" 2:"+derKey[6*rundenIndex+2]
        //  +" 3:"+derKey[6*rundenIndex+3]+" 4:"+derKey[6*rundenIndex+4]+" 5:"+derKey[6*rundenIndex+5]);
        return result;
    }
    
    private int[] schlussRunde(int[] daten, int[] derKey){
        int[] result= {produkt(daten[0], derKey[48]), 
                       summe(daten[2], derKey[49]), // ACHTUNG: Bei der Beschreibung etwas unklar,
                       summe(daten[1], derKey[50]), // dass hier die Daten getauscht werden mssen!!!
                       produkt(daten[3], derKey[51])};
        // System.out.println("Schluss \nDaten 0:"+result[0]+" 1:"+result[1]+" 2:"+result[2]+" 3:"+result[3]);
        // System.out.println("key 0:"+derKey[48]+" 1:"+derKey[49]+" 2:"+derKey[50]+" 3:"+derKey[51]);
        return result;
    }
    
    public void makeDeKeys(){
        deKeys[0]=multInv(keys[48]);
        deKeys[1]=addInv(keys[49]);
        deKeys[2]=addInv(keys[50]);
        deKeys[3]=multInv(keys[51]);
        deKeys[4]=keys[46];
        deKeys[5]=keys[47];
        for (int i=1;i<8;i++){
            deKeys[6*i]=multInv(keys[48-6*i]); 
            deKeys[6*i+1]=addInv(keys[50-6*i]); // mittlere keys getauscht
            deKeys[6*i+2]=addInv(keys[49-6*i]);
            deKeys[6*i+3]=multInv(keys[51-6*i]);
            deKeys[6*i+4]=keys[46-6*i];
            deKeys[6*i+5]=keys[47-6*i];
        }
        deKeys[48]=multInv(keys[0]);
        deKeys[49]=addInv(keys[1]);
        deKeys[50]=addInv(keys[2]);
        deKeys[51]=multInv(keys[3]);
    }
    
    // ****************  Rechenmetoden  ****************
    /**
     * bildet die Summe mod 65536,
     * also in 0...65536
     */
    private int summe(int x, int y){ return (x + y) % 65536; }
    
    /**
     * bildet das Produkt mod 65537,
     * in 1...65537, dann modulo 65536
     */
    private int produkt(int x, int y){
        long result = nullKorrektur(x)*nullKorrektur(y);
        result=(result % 65537) % 65536;
        return (int)result;
    }
    
    private long nullKorrektur(int x){ if (x==0) return 65536; else return x; }
    
    /**
     * bildet die exclusiv or - Verknpfung.
     * Problem: bei der xor - Verknpfung werden auch die vorderen Stellen verknpft.
     * Daher muss danach mit 65535 (binr:1111111111111111) und - verknpft werden.
     */
    private int xor(int x, int y){ return ((x ^ y) & 65535); }
    
    private int multInv(int a){ return potMod(a,65535,65537); }
    private int potMod(int basis, int hoch, int mod){
        if (hoch==0) return 1;
        else if (hoch==1) return basis;
        else if ((hoch%2)==0) return potMod(produkt(basis,basis),hoch/2,mod);
        else return produkt(basis,potMod(basis,hoch-1,mod));
    }
    private int addInv(int n){ return (65536-n)%65536; }
    
    // nicht gewollte get - Funktionen
//     public int[] getKey(){ return keys;}
//     public void displayKeys(){ for (int i=0;i<52;i++) System.out.println(keys[i]); }
//     public void displayDeKeys(){ for (int i=0;i<52;i++) System.out.println(deKeys[i]); }
//     public void zeigeDaten(){ System.out.println("Daten : "); for (int i=0;i<4;i++) System.out.println(daten[i]); }
//     public void zeigeCode(){ System.out.println("Code  : "); for (int i=0;i<4;i++) System.out.println(code[i]); }
//     public void zeigeDeCode(){ System.out.println("DeCode: "); for (int i=0;i<4;i++) System.out.println(deCode[i]); }
}
